]> arthur.barton.de Git - backup-script.git/blob - bin/backup-audit
backup-audit: Don't skip systems with errors, only print a warning
[backup-script.git] / bin / backup-audit
1 #!/bin/bash
2 #
3 # backup-script system for cloning systems using rsync
4 # Copyright (c)2008-2018 Alexander Barton, alex@barton.de
5 #
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10 # Please read the file COPYING, README and AUTHORS for more information.
11 #
12
13 NAME=$(basename "$0")
14
15 VERBOSE=0
16 QUIET=0
17
18 export LC_ALL=C
19
20 # Default settings, can be overwritten in backup-script.conf:
21 [ -d "/usr/local/etc/backup-script.d" ] \
22         && conf_d="/usr/local/etc/backup-script.d" \
23         || conf_d="/etc/backup-script.d"
24
25 default_backup_type="rsync"
26 default_files="running-config"
27 default_generations=0
28 default_target="/var/backups"
29
30 # Set shell options.
31 shopt -s nullglob
32
33 # Search configuration file (last one is used as default!)
34 for conf in \
35         "/usr/local/etc/backup-script.conf" \
36         "/etc/backup-script.conf" \
37         "${conf_d}/backup-script.conf" \
38         "/usr/local/etc/backup-script.conf" \
39 ; do
40         if [ -r "$conf" ]; then
41                 # shellcheck source=/dev/null
42                 source "$conf"
43                 break
44         fi
45 done
46
47 Usage() {
48         echo "Usage: $NAME [-q|--quiet] [-v|--verbose] [<job> [<job> [...]]]"
49         echo "       $NAME <-d|--dirs> <dir1> <dir2>"
50         echo
51         echo "  -d, --dirs      Compare two backup directories (not jobs)."
52         echo "  -q, --quiet     Quite mode, only list jobs with changes or errors."
53         echo "  -v, --verbose   Verbose mode, show all checks that are run."
54         echo
55         echo "When no <job> is given, all defined jobs are checked."
56         echo
57         exit 2
58 }
59
60 BeginDiff() {
61         echo "Differences in $*:"
62 }
63
64 PipeDiff() {
65         local line
66         IFS=
67         while read -r line; do
68                 echo -e "     | $line"
69         done
70 }
71
72 EndDiff() {
73         :
74 }
75
76 ListDirectory() {
77         local base_dir="$1"
78         local dir_name="$2"
79
80         local exclude
81
82         exclude=' \.$'
83         if [[ "$dir_name" == "/" ]]; then
84                 exclude="$exclude"'| \.stamp$| dev$| etc$| proc$| root$| run$| sys$| tmp$'
85                 exclude="$exclude"'| data$| net$| srv$'
86                 exclude="$exclude"'| [[:alnum:]_-]+\.log(\.[[:alnum:]]+|)$'
87         fi
88
89         # shellcheck disable=SC2012
90         find "$base_dir$dir_name". -maxdepth 1 -printf '%M %10u:%-10g %t %12s  %f\n' 2>/dev/null \
91                 | LC_ALL=C sort -k 9 | grep -Ev "($exclude)"
92 }
93
94 HandleSystem() {
95         local fname="$1"
96
97         # Set global defaults
98         local backup_type="$default_backup_type"
99         local files="$default_files"
100         local generations="$default_generations"
101         local local=0
102         local system="$fname"
103         local target="$default_target"
104
105         # Read in system configuration file
106         # shellcheck source=/dev/null
107         source "$f"
108
109         target="$target/$(basename "$f")"
110
111         [[ -d "$target" ]] || return 0
112
113         # System name
114         [[ "$system" == "$fname" ]] \
115                 && systxt="\"$system\"" \
116                 || systxt="\"$fname\" [\"$system\"]"
117         [[ "$local" -eq 0 ]] \
118                 && echo "Checking $systxt ..." \
119                 || echo "Checking $systxt (local system) ..."
120
121         # Check if job is disabled
122         if [[ "$backup_type" == "disabled" ]]; then
123                 echo "Job is DISABLED and will be skipped."
124                 echo; return 0
125         fi
126
127         if [ $generations -lt 1 ]; then
128                 echo "No generations configured, nothing to compare, skipping system!"
129                 echo; return 1
130         fi
131
132         local latest_d="$target/latest"
133         if [[ ! -d "$latest_d" || ! -r "$latest_d/.stamp" ]]; then
134                 echo "Failed to access latest backup generation in \"$latest_d\", skipping system!"
135                 echo; return 1
136         fi
137         echo "Found latest generation in \"$latest_d\"."
138
139         declare -i code=-1
140         # shellcheck source=/dev/null
141         source "$latest_d/.stamp"
142
143         if [[ $code -ne 0 ]]; then
144                 echo "Warning: Last backup generation had errors, code $code!"
145         fi
146
147         # Search previous generation without errors
148         local previous_d=""
149         # shellcheck disable=SC2045
150         for d in $(ls -1dt "$target/"[0-9]*-[0-9]* 2>/dev/null); do
151                 [[ -d "$d" && -r "$d/.stamp" ]] || return 0
152
153                 declare -i code=-1
154                 # shellcheck source=/dev/null
155                 source "$d/.stamp"
156
157                 if [[ $code -eq 0 || $code -eq 24 ]]; then
158                         previous_d="$d"
159                         break
160                 fi
161         done
162         if [[ -z "$previous_d" || ! -d "$previous_d" || ! -r "$previous_d/.stamp" ]]; then
163                 echo "Failed to find previous successfull backup generation, skipping system!"
164                 echo; return 1
165         fi
166         echo "Comparing with generation in $previous_d ..."
167
168         DiffGenerations "$backup_type" "$previous_d" "$latest_d" "$files"
169         return_code=$?
170
171         echo
172         return $return_code
173 }
174
175 DiffGenerations() {
176         local backup_type="$1"
177         local gen1_d="$2"
178         local gen2_d="$3"
179         local files="$4"
180
181         local return_code=0
182
183         if [[ "$backup_type" == "rsync" ]]; then
184                 # rsync Backup Type
185
186                 for file in \
187                         /etc/passwd \
188                         /etc/shadow \
189                         /etc/group \
190                         /etc/gshadow \
191                         \
192                         /boot/grub/grub.cfg \
193                         /etc/aliases \
194                         /etc/bash.bashrc \
195                         /etc/crontab \
196                         /etc/debian_version \
197                         /etc/environment \
198                         /etc/fstab \
199                         /etc/hostname \
200                         /etc/hosts \
201                         /etc/hosts.allow \
202                         /etc/hosts.deny \
203                         /etc/inittab \
204                         /etc/ld.so.conf \
205                         /etc/login.defs \
206                         /etc/machine-id \
207                         /etc/modules \
208                         /etc/network/interfaces \
209                         /etc/networks \
210                         /etc/nsswitch.conf \
211                         /etc/profile \
212                         /etc/rc.local \
213                         /etc/resolv.conf \
214                         /etc/services \
215                         /etc/shells \
216                         /etc/ssh/sshd_config \
217                         /etc/sshd_config \
218                         /etc/sudoers \
219                         /etc/sysctl.conf \
220                 ; do
221                         [[ -r "${gen1_d}${file}" ]] || continue
222
223                         [[ $VERBOSE -ne 0 ]] && echo "Checking \"$file\" ..."
224                         if ! diff -U 3 "${gen1_d}${file}" "${gen2_d}${file}" >"$tmp_diff"; then
225                                 BeginDiff "\"$file\""
226                                 tail -n +3 "$tmp_diff" | PipeDiff
227                                 EndDiff
228                                 return_code=1
229                         fi
230                 done
231
232                 for dir in \
233                         / \
234                         /etc/cron.d/ \
235                         /etc/cron.daily/ \
236                         /etc/cron.hourly/ \
237                         /etc/cron.monthly/ \
238                         /etc/cron.weekly/ \
239                         /etc/init.d/ \
240                         /etc/sudoers.d/ \
241                         /etc/systemd/network/ \
242                         /etc/systemd/system/ \
243                         /etc/systemd/user/ \
244                         /var/log/dumps/ \
245                 ; do
246                         [[ ! -d "${gen1_d}${dir}" ]] && continue
247                         [[ ! -d "${gen2_d}${dir}" ]] && continue
248
249                         # Make sure that this is a system root; comparing other
250                         # root folders results in misleading output ...
251                         [[ "$dir" == "/" && ! -d "${gen1_d}${dir}/etc" ]] && continue
252
253                         [[ $VERBOSE -ne 0 ]] && echo "Checking \"$dir\" ..."
254                         ListDirectory "${gen1_d}" "${dir}" >"$tmp_1"
255                         ListDirectory "${gen2_d}" "${dir}" >"$tmp_2"
256                         if ! diff -U 0 "$tmp_1" "$tmp_2" >"$tmp_diff"; then
257                                 BeginDiff "\"$dir\" directory"
258                                 tail -n +3 "$tmp_diff" | egrep -v '^@@ ' | PipeDiff
259                                 EndDiff
260                                 return_code=1
261                         fi
262                 done
263
264                 if [[ -d "${gen1_d}/var/lib/dpkg/info" && -d "${gen2_d}/var/lib/dpkg/info" ]]; then
265                         [[ $VERBOSE -ne 0 ]] && echo "Checking list of installed packages ..."
266                         chroot "${gen1_d}" dpkg --get-selections >"$tmp_1" || return 2
267                         chroot "${gen2_d}" dpkg --get-selections >"$tmp_2" || return 2
268                         if ! diff -U 0 "$tmp_1" "$tmp_2" >"$tmp_diff"; then
269                                 BeginDiff "list of installed packages"
270                                 tail -n +3 "$tmp_diff" | grep -v '^@@ ' | PipeDiff
271                                 EndDiff
272                                 return_code=1
273                         fi
274                 fi
275         elif [[ "$backup_type" == "scp" ]]; then
276                 # scp Backup type
277                 file=$(basename "$files")
278                 [[ $VERBOSE -ne 0 ]] && echo "Checking \"$file\" ..."
279                 if ! diff -U 3 "${gen1_d}/${file}" "${gen2_d}/${file}" >"$tmp_diff"; then
280                         BeginDiff "\"$file\""
281                         tail -n +3 "$tmp_diff" | PipeDiff
282                         EndDiff
283                         return_code=1
284                 fi
285         else
286                 echo "Backup type \"$backup_type\" undefined, \"$system\" skipped!"
287                 echo; return 2
288         fi
289
290         return $return_code
291 }
292
293 MkTempFiles() {
294         tmp_1=$(mktemp "/tmp/$NAME.XXXXXX") || exit 1
295         tmp_2=$(mktemp "/tmp/$NAME.XXXXXX") || exit 1
296         tmp_diff=$(mktemp "/tmp/$NAME.XXXXXX") || exit 1
297         tmp_out=$(mktemp "/tmp/$NAME.XXXXXX") || exit 1
298 }
299
300 CleanUp() {
301         rm -f "$tmp_1" "$tmp_2" "$tmp_diff" "$tmp_out"
302 }
303
304 while [[ $# -gt 0 ]]; do
305         case "$1" in
306           "-d"|"--dirs")
307                 shift
308                 [[ $# -eq 2 ]] || Usage
309                 MkTempFiles
310                 DiffGenerations "$default_backup_type" "$1" "$2" "$default_files"
311                 return_code=$?
312                 CleanUp
313                 exit $return_code
314                 ;;
315           "-q"|"--quiet")
316                 QUIET=1; shift
317                 ;;
318           "-v"|"--verbose")
319                 VERBOSE=1; shift
320                 ;;
321           "-"*)
322                 Usage
323                 ;;
324           *)
325                 break
326         esac
327 done
328
329 if [[ $# -ge 1 ]]; then
330         for s in "$@"; do
331                 if [ ! -r "${conf_d}/$s" ]; then
332                         echo "$NAME: Can' read \"${conf_d}/$s\"!"
333                         exit 1
334                 fi
335                 sys+=("${conf_d}/$s")
336         done
337 else
338         sys=("${conf_d}/"*)
339 fi
340
341 MkTempFiles
342 for f in "${sys[@]}"; do
343         [[ -r "$f" && -f "$f" ]] || continue
344
345         fname=$(basename "$f")
346         case "$fname" in
347                 "backup-script.conf"|*.sh)
348                         continue
349                         ;;
350         esac
351
352         HandleSystem "$fname" >"$tmp_out" 2>&1; result=$?
353         [[ $QUIET -eq 0 || $result -ne 0 ]] && cat "$tmp_out"
354 done
355 CleanUp
356
357 # -eof-